////////////////////////////////////////
// Complementary Reimagined by EminGT //
////////////////////////////////////////

//Common//
#include "/lib/common.glsl"

//////////Fragment Shader//////////Fragment Shader//////////Fragment Shader//////////
#ifdef FRAGMENT_SHADER

in vec4 position;
flat in vec4 glColor;

//Pipeline Constants//

//Common Variables//

//Common Functions//
void DoNaturalShadowCalculation(inout vec4 color1, inout vec4 color2) {
    //color1.rgb *= glColor.rgb;
    color1.rgb = mix(vec3(1.0), color1.rgb, pow(color1.a, (1.0 - color1.a) * 0.5) * 1.05);
    color1.rgb *= 1.0 - pow(color1.a, 64.0);
    color1.rgb *= 0.2; // Natural Strength

    color2.rgb = normalize(color1.rgb) * 0.5;
}

//Includes//

//Program//
void main() {
    vec4 color1 = glColor; // Shadow Color

    #if SHADOW_QUALITY >= 1
        vec4 color2; // Light Shaft Color

        DoNaturalShadowCalculation(color1, color2);
    #endif

    gl_FragData[0] = color1; // Shadow Color

    #if SHADOW_QUALITY >= 1
        #if defined LIGHTSHAFTS_ACTIVE && LIGHTSHAFT_BEHAVIOUR == 1 && defined OVERWORLD
            color2.a = 0.25 + max0(position.y * 0.05); // consistencyMEJHRI7DG
        #endif

        gl_FragData[1] = color2; // Light Shaft Color
    #endif
}

#endif

//////////Vertex Shader//////////Vertex Shader//////////Vertex Shader//////////
#ifdef VERTEX_SHADER

out vec4 position;
flat out vec4 glColor;

//Attributes//

//Common Variables//

//Common Functions//

//Includes//

//Program//
void main() {
    position = shadowModelViewInverse * shadowProjectionInverse * ftransform();
    gl_Position = shadowProjection * gl_ModelViewMatrix * gl_Vertex;

    //float lVertexPos = sqrt(gl_Position.x * gl_Position.x + gl_Position.y * gl_Position.y);
    //float distortFactor = lVertexPos * shadowMapBias + (1.0 - shadowMapBias);
    //gl_Position.xy *= 1.0 / distortFactor;
    gl_Position.z = gl_Position.z * 0.1 + 0.0;

    glColor = gl_Color;

    #ifdef DISTANT_HORIZONS
        gl_Position.x -= 1.0;
        gl_Position.x *= 0.5;
        gl_Position.x += 1.0;
    #endif
}

#endif
